#include "stopwatch.h"

int M2Util::Stopwatch::check(){
   if(paused){
      return (int)(pausetime-prevtime)+timeOffset;
   }
   return timerfunc(0);
}

int M2Util::Stopwatch::pause(){
   unsigned int curtime = SDL_GetTicks();
   pausetime = curtime;
   paused = true;
   return timerfunc(0);
}

int M2Util::Stopwatch::resume(){
   unsigned int curtime = SDL_GetTicks();
   if(paused){
      prevtime+=curtime-pausetime;
   }
   paused = false;
   return timerfunc(0);
}

void M2Util::Stopwatch::start(){
   timerfunc(0);
}

int M2Util::Stopwatch::stop(){
   started = false;
   if(paused){
      return int(pausetime-prevtime)+timeOffset;
   }else{
      return int(SDL_GetTicks()-prevtime)+timeOffset;
   }
}

int M2Util::Stopwatch::timerfunc(bool reset){
   unsigned int curtime = SDL_GetTicks();
   if(!started){
      prevtime=curtime;
      started = true;
      return (0)+timeOffset;
   }else{
      unsigned int diff=curtime-prevtime;
      if(reset){prevtime=curtime;}
      return int(diff)+timeOffset;
   }
}

int M2Util::Stopwatch::delta(const std::string &deltaName, bool resetDelta){
   if(deltaVals.find(deltaName) == deltaVals.end()){ //if no delta by that name is found
      deltaVals[deltaName].deltaspot = check();  //set the delta to the current time
      return 0;
   }
   unsigned int PreviousTime = deltaVals[deltaName].deltaspot;
   unsigned int CurrentTime = check();
   if(resetDelta){
      deltaVals[deltaName].deltaspot = CurrentTime; //update delta
   }
   return CurrentTime - PreviousTime;
}

void M2Util::Stopwatch::setTimeOffset( int offsetMilliseconds ){
   timeOffset = offsetMilliseconds;
}

int M2Util::Stopwatch::getTimeOffset(){
   return timeOffset;
}
